Attribute VB_Name = "SCR_Module"
'Password Functions
Declare Function PwdChangePassword Lib "mpr" Alias "PwdChangePasswordA" (ByVal lpcRegkeyname As String, ByVal hWnd As Long, ByVal uiReserved1 As Long, ByVal uiReserved2 As Long) As Long
Declare Function VerifyScreenSavePwd Lib "password.cpl" (ByVal hWnd As Long) As Boolean
'Graphics Functions
Declare Function CreateDC Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName As String, ByVal lpDeviceName As String, ByVal lpOutput As String, ByVal lpInitData As Long) As Long
Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function StretchBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
'Misc Functions
Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Declare Function GetClientRect Lib "user32" (ByVal hWnd&, lpRect As RECT) As Long
Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long
Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long
Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long
Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, lpvParam As Any, ByVal fuWinIni As Long) As Long
Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
'Registry Functions
Declare Function RegOpenKeyExA Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpszSubKey As String, dwOptions As Long, ByVal samDesired As Long, lpHKey As Long) As Long
Declare Function RegQueryValueExA Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpszValueName As String, lpdwRes As Long, lpdwType As Long, ByVal lpDataBuff As String, nSize As Long) As Long
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
'Subclassing Functions
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Any) As Long
Public Const GWL_WNDPROC = (-4)
'Important Public Variables
Public xPixel As Long, yPixel As Long
Public PictureLoaded As Boolean, CPWindow As Long, CPRect As RECT
'Misc Constants
Public Const WM_CLOSE = &H10
Public Const SPI_SCREENSAVERRUNNING = 97
Public Const SWP_HIDEWINDOW = &H80
Public Const SWP_SHOWWINDOW = &H40
Public Const SWP_NOMOVE = 2
Public Const SWP_NOSIZE = 1
Public Const FLAGS = SWP_NOMOVE Or SWP_NOSIZE
Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2
'Registry Constants
Public Const HKEY_CURRENT_USER = &H80000001
Public Const KEY_QUERY_VALUE = &H1&
Public Const KEY_ENUMERATE_SUB_KEYS = &H8&
Public Const KEY_NOTIFY = &H10&
Public Const READ_CONTROL = &H20000
Public Const STANDARD_RIGHTS_READ = READ_CONTROL
Public Const Key_Read = STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY
Public Const REG_DWORD = 4&
'Rectangle Type Declaration
Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
Type POINTAPI
    X As Long
    Y As Long
End Type
Declare Function SetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Declare Function GetTickCount Lib "kernel32" () As Long

Public XStart As Integer, YStart As Integer
Public screenCounter As Integer
Public ImagePath As String
Public Const SRCAND As Long = &H8800C6
Public Const SRCPAINT  As Long = &HEE0086
Public Const SRCCOPY  As Long = &HCC0020
Public Const SRCINVERT = &H660046
Public ImageList() As String
Public disNum As Integer
Public imageTrans As String
Public Const TC = 18
Public noTrans As Boolean
Public listDis As Boolean
Public trandel As Long
Public SubOn As Byte
Public lastN As Integer
Sub CopyScreen(frm As Object)

Dim ScreenDC As Long
frm.AutoRedraw = True
ScreenDC = CreateDC("DISPLAY", "", "", 0&)
TEMPLong = StretchBlt(frm.hDC, 0, 0, frm.Width, frm.Height, ScreenDC, 0, 0, Screen.Width, Screen.Height, &HCC0020)
TEMPLong = DeleteDC(ScreenDC)
frm.AutoRedraw = False

End Sub
Public Sub LoadImages()
  Dim FP As FILE_PARAMS
  Dim temp(1 To 3) As String
  temp(1) = "*.bmp"
  temp(2) = "*.jpg"
  temp(3) = "*.gif"
  For i = 1 To 3
    With FP
      .sFileNameExt = temp(CInt(i))
      .sFileRoot = ImagePath
    End With
    ReDim sAllFiles(1 To 1000000) As String
    Call GetAllFilesSpecified(FP)
    If nCount > 0 Then
      If bCancel = False Then
        ReDim Preserve sAllFiles(1 To nCount)
        lastN = nCount + lastN
        ReDim Preserve ImageList(1 To lastN)
        Call SaveImageList
      End If
    Else
      ScreenSaver.pic.Picture = ScreenSaver.Picture1.Picture
      ScreenSaver.pic.Width = ScreenSaver.Picture1.Width + 1
      ScreenSaver.pic.Height = ScreenSaver.Picture1.Height + 1
    End If
    Erase sAllFiles()
  Next i
End Sub
Public Sub loadImagePath()
  ImagePath = GetSetting(App.EXEName, "Config", "Image Path", "C:\Windows\")
  disNum = GetSetting(App.EXEName, "Config", "DisNum", 5)
  imageTrans = GetSetting(App.EXEName, "Config", "Transitions", "010203040506070809101112131415161718")
  listDis = GetSetting(App.EXEName, "Config", "ListDis", "False")
  trandel = GetSetting(App.EXEName, "Config", "Delay", "6")
  SubOn = GetSetting(App.EXEName, "Config", "SubOn", "0")
  Config.Text1.Text = ImagePath
  Config.Text2.Text = disNum
  Config.Text3.Text = trandel
  Config.Text1.SelStart = Len(Config.Text1)
  Config.Check2.Value = SubOn
  '**************************************
  updateListView
  If listDis = False Then
    Config.Check1.Value = 1
    Config.ListView1.Enabled = True
  Else
    Config.Check1.Value = 0
    Config.ListView1.Enabled = False
  End If
End Sub

Public Sub tempeffect13(frm As Object)
Randomize Timer
temp = CInt(Rnd * 10)
For X = ScreenSaver.pic.Width - 1 To 1 Step -1
  For Y = ScreenSaver.pic.Height - 1 To 1 Step -1
    Colour = ScreenSaver.pic.Point(X, Y) * -1
    Call SetPixel(frm.hDC, XStart + X, YStart + Y, Colour)
  Next Y
  DoEvents
  frm.Refresh
Next X
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub

Public Sub tempeffect12(frm As Object)
Dim a As Long, red As Integer, green As Integer, blue As Integer
For X = 1 To ScreenSaver.pic.ScaleWidth - 1
  For Y = 1 To ScreenSaver.pic.ScaleHeight - 1
    a = ScreenSaver.pic.Point(X, Y)
    ColorSplit a, red, green, blue
    frm.PSet (X + XStart, Y + YStart), RGB((red + green + blue) \ 3, (red + green + blue) \ 3, (red + green + blue) \ 3)
  Next Y
DoEvents
Next X
For X = ScreenSaver.pic.ScaleWidth - 1 To 1 Step -1
  For Y = 1 To ScreenSaver.pic.ScaleHeight - 1
    frm.PSet (X + XStart, Y + YStart), 16777215 - frm.Point(X + XStart, Y + YStart)
  Next Y
  DoEvents
Next X
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub
Public Sub tempeffect11(frm As Object)
Dim a As Long, red As Integer, green As Integer, blue As Integer
For X = 1 To ScreenSaver.pic.ScaleWidth - 1
  For Y = 1 To ScreenSaver.pic.ScaleHeight - 1
    a = ScreenSaver.pic.Point(X, Y)
    ColorSplit a, red, green, blue
    ScreenSaver.PSet (X + XStart, Y + YStart), RGB((red + green + blue) \ 3, (red + green + blue) \ 3, (red + green + blue) \ 3)
  Next Y
DoEvents
Next X
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub
Function ColorSplit(RGBMix As Long, R%, G%, B%)
  R% = RGBMix And &HFF
  G% = (RGBMix \ &H100) And &HFF
  B% = (RGBMix \ &H10000) And &HFF
End Function


Public Sub updateImagePath()
  SaveSetting App.EXEName, "Config", "Image Path", ImagePath
  SaveSetting App.EXEName, "Config", "DisNum", disNum
  SaveSetting App.EXEName, "Config", "Transitions", imageTrans
  SaveSetting App.EXEName, "Config", "ListDis", listDis
  SaveSetting App.EXEName, "Config", "Delay", trandel
  SaveSetting App.EXEName, "Config", "SubOn", SubOn
End Sub


Sub Main()
'Initializes 2 Important Variables
xPixel = Screen.TwipsPerPixelX
yPixel = Screen.TwipsPerPixelY

loadImagePath

'Check Command Line Arguments
CommandLine$ = UCase(Left(Command$, 2))     'Gets Command Line Arguments
Select Case CommandLine$
    Case "/C":
        Config.Show 1                       'Shows Config Form
        Exit Sub
    Case "/P":
        'CPWindow = Val(Mid(Command, 4, 8))  'Loads Display Properties Test
        'Load DisplayTest                    'Screen Saver
        For Each frm In Forms
          Unload frm
        Next
        End
    Case "/A"
        'Determines if User Wants to Change the Password
        CPWindow = Val(Mid(Command, 4, 8))
        PassWordChange.Show 1
        Exit Sub
    Case "/S":
        If App.PrevInstance = True Then
            Exit Sub
        End If
        LoadImages
        ScreenSaver.Show 1                  'Show the Screen Saver form
        Exit Sub
End Select

'If no Options then Show Config Form
Config.Show 1

End Sub
Public Sub Msghook(ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long, Result As Long)
    
'Respond to the WM_CLOSE message sent to the picture box
'when the Display Properties dialog has gone on to something
'else or has gone away.

Select Case wMsg
Case WM_CLOSE
    'Putting the picture box back where it started may not
    'be absolutely necessary, but it is good coding practice
    TEMPLong = SetParent(DisplayTest.DisplayPic.hWnd, hWnd)
    'Unset the flag, so the timer will close the instance
    'rather than writing to the picture box
    PictureLoaded = False
End Select

End Sub
Function RegGetValue(MainKey As Long, SubKey As String, Value As String) As String
   
'MainKey must be one of the Publicly declared HKEY constants.
Dim sKeyType As Long       'returns the key type.  This function expects REG_SZ
Dim ret As Long            'returned by registry functions, should be 0&
Dim lpHKey As Long         'return handle to opened key
Dim lpcbData As Long       'length of data in returned string
Dim ReturnedString As String  'returned string value
Dim fTempDbl As Double

If MainKey >= &H80000000 And MainKey <= &H80000006 Then
    'Open key
    ret = RegOpenKeyExA(MainKey, SubKey, 0&, Key_Read, lpHKey)
    If ret <> 0 Then
        RegGetValue = ""
        Exit Function     'No key open, so leave
    End If
   
    'Set up buffer for data to be returned in.
    'Adjust next value for larger buffers.
    lpcbData = 255
    ReturnedString = Space(lpcbData)
   
    'Read key
    ret = RegQueryValueExA(lpHKey, Value, ByVal 0&, sKeyType, ReturnedString, lpcbData)
    If ret <> 0 Then
        RegGetValue = ""   'Key still open, so finish up
    Else
        If sKeyType = REG_DWORD Then
            fTempDbl = Asc(Mid(ReturnedString, 1, 1)) + &H100& * Asc(Mid(ReturnedString, 2, 1)) + &H10000 * Asc(Mid(ReturnedString, 3, 1)) + &H1000000 * CDbl(Asc(Mid(ReturnedString, 4, 1)))
            ReturnedString = Format(fTempDbl, "000")
        End If
        RegGetValue = Left(ReturnedString, lpcbData - 1)
    End If
      'Always close opened keys!
      ret = RegCloseKey(lpHKey)
End If

End Function
Public Sub chooseTransformMethod(frm As Object)
Randomize Timer
NewPicture
XStart = CInt(Rnd * (frm.ScaleWidth - ScreenSaver.pic.Width))
YStart = CInt(Rnd * (frm.ScaleHeight - ScreenSaver.pic.Height))
If noTrans = False Then
  method = CInt(Rnd * (TC - 1)) + 1
  While Config.ListView1.ListItems(method).Checked = False
    method = CInt(Rnd * (TC - 1)) + 1
  Wend
  screenCounter = screenCounter + 1
  If screenCounter > disNum Then
    frm.Cls
    screenCounter = 0
  End If
  Select Case method
    Case 1:  TartanImage frm
    Case 2:  FlagImage frm
    Case 3:  BlindImage frm
    Case 4:  LaserImage frm
    Case 5:  AndImage frm
    Case 6:  tempEffect1 frm
    Case 7:  tempEffect2 frm
    Case 8:  tempEffect3 frm
    Case 9:  tempEffect4 frm
    Case 10: tempEffect5 frm
    Case 11: tempEffect6 frm
    Case 12: tempEffect7 frm
    Case 13: tempEffect8 frm
    Case 14: tempeffect9 frm
    Case 15: tempeffect10 frm
    Case 16: tempeffect11 frm
    Case 17: tempeffect12 frm
    Case 18: tempeffect13 frm
  End Select
Else
  ShowPicture frm
  screenCounter = screenCounter + 1
  If screenCounter > disNum Then
    frm.Cls
    screenCounter = 0
  End If
End If
End Sub
Public Sub LaserImage(frm As Object)
Randomize Timer
temp = Int(5 * Rnd) + 1
While temp > 4
  temp = Int(5 * Rnd) + 1
Wend
Select Case temp
  Case 1:
    For X = 1 To ScreenSaver.pic.Width - 1
      For Y = 1 To ScreenSaver.pic.Height - 1
        Colour = ScreenSaver.pic.Point(X, Y)
        frm.Line (XStart + ScreenSaver.pic.Width, YStart + ScreenSaver.pic.Height)-(X + XStart, Y + YStart), Colour
      Next Y
      DoEvents
    Next X
  Case 2:
    For Y = 1 To ScreenSaver.pic.Height - 1
      For X = ScreenSaver.pic.Width - 1 To 1 Step -1
        Colour = ScreenSaver.pic.Point(X, Y)
        frm.Line (XStart, YStart + ScreenSaver.pic.Height)-(X + XStart, Y + YStart), Colour
      Next X
      DoEvents
    Next Y
  Case 3:
    For X = ScreenSaver.pic.Width - 1 To 1 Step -1
      For Y = ScreenSaver.pic.Height - 1 To 1 Step -1
        Colour = ScreenSaver.pic.Point(X, Y)
        frm.Line (XStart, YStart)-(X + XStart, Y + YStart), Colour
      Next Y
      DoEvents
    Next X
  Case 4:
    For Y = ScreenSaver.pic.Height - 1 To 1 Step -1
      For X = 1 To ScreenSaver.pic.Width - 1
        Colour = ScreenSaver.pic.Point(X, Y)
        frm.Line (XStart + ScreenSaver.pic.Width, YStart)-(X + XStart, Y + YStart), Colour
      Next X
      DoEvents
    Next Y
End Select
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub
Public Sub NewPicture()
Randomize Timer
If nCount > 0 Then
  temp = CInt(Rnd * (nCount - 1)) + 1
  If ImageList(temp) <> "" Then
    ScreenSaver.pic.AutoRedraw = False
    If Left(Right(ImageList(temp), 4), 1) = "." Then
      ScreenSaver.pic.Picture = LoadPicture(ImageList(temp))
      If ScreenSaver.pic.Width < 1.5 * ScreenSaver.ScaleWidth Or _
         ScreenSaver.pic.Height < 1.5 * ScreenSaver.ScaleHeight Then
         ScreenSaver.pic.Width = ScreenSaver.pic.Width + 1
         ScreenSaver.pic.Height = ScreenSaver.pic.Height + 1
         ScreenSaver.pic.AutoRedraw = True
      Else
        NewPicture
      End If
    Else
      NewPicture
    End If
  Else
      NewPicture
  End If
Else
  ScreenSaver.pic.AutoRedraw = True
  ScreenSaver.pic.Picture = ScreenSaver.Picture1.Picture
  ScreenSaver.pic.Width = ScreenSaver.Picture1.Width + 1
  ScreenSaver.pic.Height = ScreenSaver.Picture1.Height + 1
End If
End Sub
Public Sub FlagImage(frm As Object)
Dim X As Integer
Dim Y As Integer
For Y = 1 To 250
    For X = 1 To ScreenSaver.pic.Width
      Call BitBlt(frm.hDC, X + XStart, YStart + 2 * Sin((X - Y) / 8), 2, ScreenSaver.pic.ScaleHeight, ScreenSaver.pic.hDC, X, 0, SRCCOPY)
    Next X
    DoEvents
    frm.Refresh
Next Y
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub
Public Sub tempeffect10(frm As Object)
xcount = XStart
For X = 1 To ScreenSaver.pic.Width - 1
  ycount = YStart
  For Y = 1 To ScreenSaver.pic.Height - 1
    Colour = ScreenSaver.pic.Point(X, Y)
    Call SetPixel(frm.hDC, xcount + 1, ycount + 1, Colour)
    Call SetPixel(frm.hDC, xcount + 1, ycount + 2, Colour)
    Call SetPixel(frm.hDC, xcount + 2, ycount + 1, Colour)
    ycount = ycount + 2
  Next Y
  xcount = xcount + 2
  DoEvents
  frm.Refresh
Next X
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub

Public Sub tempeffect9(frm As Object)
For X = 1 To ScreenSaver.pic.Width - 1 Step 2
  For Y = 1 To ScreenSaver.pic.Height - 1 Step 2
    Colour = ScreenSaver.pic.Point(X, Y)
    Call SetPixel(frm.hDC, XStart + X, YStart + Y, Colour)
    Call SetPixel(frm.hDC, XStart + X + 1, YStart + Y, Colour)
    Call SetPixel(frm.hDC, XStart + X, YStart + Y + 1, Colour)
  Next Y
  DoEvents
  frm.Refresh
Next X
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub

Public Sub BlindImage(frm As Object)
Dim Y As Integer
For Y = 1 To ScreenSaver.pic.Height Step 1
    Call BitBlt(frm.hDC, XStart, Y + YStart, ScreenSaver.pic.Width, 1, ScreenSaver.pic.hDC, 0, Y, SRCCOPY)
    frm.Refresh
    DoEvents
Next Y
For Y = ScreenSaver.pic.Height + 1 To 1 Step 1
    Call BitBlt(frm.hDC, XStart, Y + YStart, ScreenSaver.pic.Width, 1, ScreenSaver.pic.hDC, 0, Y, SRCCOPY)
    frm.Refresh
    DoEvents
Next Y
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub
Public Sub TartanImage(frm As Object)
Dim Y As Integer, X As Integer
For Y = 1 To ScreenSaver.pic.Height Step 10
    Call BitBlt(frm.hDC, XStart, Y + YStart, ScreenSaver.pic.Width, 2, ScreenSaver.pic.hDC, 0, Y, SRCCOPY)
    frm.Refresh
    DoEvents
Next Y
For X = 1 To ScreenSaver.pic.Height Step 10
    Call BitBlt(frm.hDC, XStart + X, YStart, 2, ScreenSaver.pic.Height, ScreenSaver.pic.hDC, X, 0, SRCCOPY)
    frm.Refresh
    DoEvents
Next X
Call BitBlt(frm.hDC, XStart, YStart, ScreenSaver.pic.Width, ScreenSaver.pic.Height, ScreenSaver.pic.hDC, 0, 0, SRCCOPY)
frm.Refresh
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub
Public Sub AndImage(frm As Object)
Call BitBlt(frm.hDC, XStart, YStart, ScreenSaver.pic.Width - 1, ScreenSaver.pic.Height - 1, ScreenSaver.pic.hDC, 0, 0, SRCAND)
'ScreenSaver.Refresh
'Call BitBlt(frm.hDC, XStart, YStart, ScreenSaver.pic.Width, ScreenSaver.pic.Height, ScreenSaver.pic.hDC, 0, 0, SRCINVERT)
frm.Refresh
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub
Public Sub ShowPicture(frm As Object)
Call BitBlt(frm.hDC, XStart, YStart, ScreenSaver.pic.Width - 1, ScreenSaver.pic.Height - 1, ScreenSaver.pic.hDC, 0, 0, SRCCOPY)
frm.Refresh
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub

Public Sub tempEffect1(frm As Object)
For Y = ScreenSaver.pic.Height - 3 To 1 Step -1
    For X = 1 To ScreenSaver.pic.Width - 3
        Colour = GetPixel(ScreenSaver.pic.hDC, X, Y)
        Call SetPixel(frm.hDC, XStart + X + X Mod 5, YStart + Y + Y Mod 5, Colour)
    Next X
    DoEvents
    frm.Refresh
Next Y
For Y = ScreenSaver.pic.Height - 1 To 1 Step -1
    For X = 1 To ScreenSaver.pic.Width - 1
        Colour = GetPixel(ScreenSaver.pic.hDC, X + Rnd * 2, Y + Rnd * 2)
        Call SetPixel(frm.hDC, XStart + X, YStart + Y, Colour)
    Next X
    DoEvents
    frm.Refresh
Next Y
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub
Public Sub tempEffect2(frm As Object)
Randomize Timer
xdir = CInt(Rnd * 99) + 1
xsign = CInt(Rnd * 1)
ydir = CInt(Rnd * 99) + 1
ysign = CInt(Rnd * 1)
If xsign = 1 Then xdir = xdir * -1
If ysign = 1 Then ydir = ydir * -1
XStart = XStart + xdir
YStart = YStart + ydir
If YStart < 0 Or YStart > frm.ScaleHeight Then ydir = ydir * -1
If XStart < 0 Or XStart > frm.ScaleWidth Then xdir = xdir * -1
For X = 1 To frm.ScaleWidth
   If X Mod 2 = 1 Then
     Colour = RGB(255, 255, 255)
   Else
     Colour = RGB(0, 0, 0)
   End If
   frm.Line (XStart, YStart)-(X, 0), Colour
   frm.Line (XStart, YStart)-(X, frm.ScaleHeight), Colour
   DoEvents
Next X
For Y = 1 To frm.ScaleHeight
   If Y Mod 2 = 1 Then
     Colour = RGB(255, 255, 255)
   Else
     Colour = RGB(0, 0, 0)
   End If
   frm.Line (XStart, YStart)-(0, Y), Colour
   frm.Line (XStart, YStart)-(frm.ScaleWidth, Y), Colour
   DoEvents
Next Y
frm.Refresh
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub
Public Sub tempEffect3(frm As Object)
For X = 1 To ScreenSaver.pic.Width - 1
  For Y = 1 To ScreenSaver.pic.Height - 1
    Colour = RGB(255, 255, 255) - ScreenSaver.pic.Point(X, Y)
    Call SetPixel(frm.hDC, XStart + X, YStart + Y + 2 * Sin(X), Colour)
  Next Y
  DoEvents
  frm.Refresh
Next X
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub
Public Sub tempEffect4(frm As Object)
rndCol = CInt(Rnd * 255)
For Y = 1 To ScreenSaver.pic.Height - 1
  For X = ScreenSaver.pic.Width - 1 To 1 Step -1
    Colour = RGB(rndCol, rndCol, rndCol) - ScreenSaver.pic.Point(X, Y)
    Call SetPixel(frm.hDC, XStart + X, YStart + Y, Colour)
  Next X
  DoEvents
  frm.Refresh
Next Y
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub
Public Sub tempEffect5(frm As Object)
Randomize Timer
temp = CInt(Rnd * 10)
For X = ScreenSaver.pic.Width - 1 To 1 Step -1
  For Y = ScreenSaver.pic.Height - 1 To 1 Step -1
    Colour = ScreenSaver.pic.Point(X, Y) * temp
    Call SetPixel(frm.hDC, XStart + X, YStart + Y, Colour)
  Next Y
  DoEvents
  frm.Refresh
Next X
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub
Public Sub tempEffect6(frm As Object)
Randomize Timer
temp = CInt(Rnd * 75)
For Y = 1 To ScreenSaver.pic.Height - 1
  For X = 1 To ScreenSaver.pic.Width - 1
    Colour = ScreenSaver.pic.Point(X, Y) + RGB(temp, temp, temp)
    Call SetPixel(frm.hDC, XStart + X, YStart + Y, Colour)
  Next X
  DoEvents
  frm.Refresh
Next Y
frm.Refresh
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub
Public Sub tempEffect7(frm As Object)
For X = 1 To ScreenSaver.pic.Width - 1
  For Y = 1 To ScreenSaver.pic.Height - 1
    Colour = (ScreenSaver.pic.Point(X + 2, Y) + ScreenSaver.pic.Point(X - 2, Y) + ScreenSaver.pic.Point(X, Y - 2) + ScreenSaver.pic.Point(X, Y + 2)) \ 4
    Call SetPixel(frm.hDC, XStart + X, YStart + Y, Colour)
  Next Y
  DoEvents
  frm.Refresh
Next X
frm.Refresh
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub

Public Sub tempEffect8(frm As Object)
For X = 1 To ScreenSaver.pic.Width - 1
  For Y = 1 To ScreenSaver.pic.Height - 1
    Colour = (ScreenSaver.pic.Point(X + 1, Y) + ScreenSaver.pic.Point(X - 1, Y) + ScreenSaver.pic.Point(X, Y - 1) + ScreenSaver.pic.Point(X, Y + 1)) ' \ 4
    Call SetPixel(frm.hDC, XStart + X, YStart + Y, Colour)
  Next Y
  DoEvents
  frm.Refresh
Next X
WaitFor trandel * 1000
chooseTransformMethod frm
End Sub
Public Sub updateListView()
  noTrans = False
  If Len(imageTrans) > 0 Then
    For i = 1 To Len(imageTrans) / 2
      Config.ListView1.ListItems(CInt(Right(Left(imageTrans, 2 * i), 2))).Checked = True
    Next i
  Else
    noTrans = True
  End If
End Sub

Public Sub WaitFor(TimeToWait As Long)
Dim TimeNow As Long
TimeNow = GetTickCount
Do While GetTickCount - TimeNow <= TimeToWait
    DoEvents
Loop
End Sub
