VERSION 5.00
Begin VB.Form DisplayTest 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Display Test"
   ClientHeight    =   1695
   ClientLeft      =   3195
   ClientTop       =   1680
   ClientWidth     =   2295
   ControlBox      =   0   'False
   Icon            =   "Display.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1695
   ScaleWidth      =   2295
   Begin VB.Timer Timer2 
      Interval        =   500
      Left            =   0
      Top             =   480
   End
   Begin VB.Timer Timer1 
      Interval        =   1
      Left            =   0
      Top             =   0
   End
   Begin VB.PictureBox DisplayPic 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      Height          =   1695
      Left            =   0
      ScaleHeight     =   113
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   153
      TabIndex        =   0
      Top             =   0
      Width           =   2295
   End
End
Attribute VB_Name = "DisplayTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private OldWindowProc As Long
Private Sub Form_Load()

'Query the size of the Display Properties Output Window
TEMPLong = GetClientRect(CPWindow, CPRect)

'Additional Stuff Goes Here
 'Such as Copy Current Screen to PictureBox


'Move the PictureBox onto the Display Properties Form
TEMPLong = SetParent(DisplayPic.hWnd, CPWindow)
    
'Sets a flag to determine if Picture is still
'Running in the Display Properties
PictureLoaded = True

'Set MsgHook (Subclass)
OldWindowProc = SetWindowLong(CPWindow, GWL_WNDPROC, AddressOf Msghook)

End Sub


Private Sub Msghook1_Message(ByVal Msg As Long, ByVal wP As Long, ByVal lP As Long, Result As Long)
    'Respond to the WM_CLOSE message sent to the picture box
    'when the Display Properties dialog has gone on to something
    'else or has gone away.
    Select Case Msg
        Case WM_CLOSE
            'Putting the picture box back where it started may not
            'be absolutely necessary, but it is good coding practice
            TEMPLong = SetParent(DisplayPic.hWnd, hWnd)
            
            'Unset the flag, so the timer will close the instance
            'rather than writing to the picture box
            PictureLoaded = False
    End Select
End Sub

Private Sub Form_Unload(Cancel As Integer)

'Set MsgHook (UnSubclass)
SetWindowLong CPWindow, GWL_WNDPROC, OldWindowProc

End Sub


Private Sub Timer1_Timer()

If IsWindow(CPWindow) = 0 Or Not PictureLoaded Then
    'If we got the WM_CLOSE message, or if the Display
    'Properties dialog somehow went away without our
    'getting the message (GPF or something).
    Unload Me: End
Else
    'Continue drawing the Circles
    chooseTransformMethod DisplayPic
End If
    
End Sub


Private Sub Timer2_Timer()

'Do Screen Saver Stuff Here...
'Calls Draw Procedure to Draw in the PictureBox
chooseTransformMethod DisplayPic

End Sub


