VERSION 5.00
Begin VB.Form ScreenSaver 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000000&
   BorderStyle     =   0  'None
   Caption         =   "Screen Saver Form"
   ClientHeight    =   7125
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   8880
   ControlBox      =   0   'False
   ForeColor       =   &H000080FF&
   Icon            =   "Main.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   475
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   592
   Visible         =   0   'False
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   1620
      Left            =   720
      Picture         =   "Main.frx":0442
      ScaleHeight     =   108
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   504
      TabIndex        =   1
      Top             =   2400
      Visible         =   0   'False
      Width           =   7560
   End
   Begin VB.Timer Timer1 
      Interval        =   500
      Left            =   375
      Top             =   255
   End
   Begin VB.PictureBox pic 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H80000001&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   6000
      Left            =   -99999
      ScaleHeight     =   400
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   320
      TabIndex        =   0
      Top             =   0
      Width           =   4800
   End
End
Attribute VB_Name = "ScreenSaver"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private oldx As Integer, oldy As Integer
Private m_BusyVerifying As Boolean, m_SavedCursorPos As POINTAPI
Sub Quit()

'Enables Ctrl-Alt-Delete + Alt Tab
Dim ret As Integer
Dim pOld As Boolean
ret = SystemParametersInfo(SPI_SCREENSAVERRUNNING, False, pOld, 0)

'Restores Cursor
Do
Loop Until ShowCursor(True) > 5

'Restores TaskBar
SetWindowPos FindWindow("Shell_traywnd", ""), 0, 0, 0, 0, 0, SWP_SHOWWINDOW

 'Sets the Form Not TOPMOST
ret = SetWindowPos(ScreenSaver.hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, FLAGS)
For Each frm In Forms
  Unload frm
  Set frm = Nothing
Next
End
End Sub
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error Resume Next
    If m_BusyVerifying = True Then Exit Sub
    Unload Me
End Sub

Private Sub Form_Load()
'Find out from the System Registry if the user
'has enabled password protection for screen savers.
'PWProtect = Val(RegGetValue(HKEY_CURRENT_USER, "Control Panel\Desktop", "ScreenSaveUsePassword"))
  
'Disables Ctrl-Alt-Delete + Alt Tab
Dim ret As Integer
Dim pOld As Boolean
ret = SystemParametersInfo(SPI_SCREENSAVERRUNNING, True, pOld, 0)

'Hides Cursor
Dim lRetVal As Long
lRetVal = GetCursorPos(m_SavedCursorPos)
lRetVal = SetCursorPos(0, 0)
Do: DoEvents: Loop Until ShowCursor(False) < 0

'Hides TaskBar
SetWindowPos FindWindow("Shell_traywnd", ""), 0, 0, 0, 0, 0, SWP_HIDEWINDOW
 
'Make the Form exactly cover the screen
Move 0, 0, Screen.Width, Screen.Height

 'Sets the Form to TOPMOST
ret = SetWindowPos(Me.hWnd, HWND_TOPMOST, 0, 0, 0, 0, FLAGS)
End Sub
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Unload Me
End Sub
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  If oldx = 0 And oldy = 0 Then
    oldx = X
    oldy = Y
  End If
  d = Sqr(Abs((Y - oldy) ^ 2 - (X - oldx) ^ 2))
  If d > 10 Then
    Unload Me
  End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Dim lRetVal         As Long
    '-----------------------------
    Do: DoEvents: Loop Until ShowCursor(True) > 0
    lRetVal = SetCursorPos(m_SavedCursorPos.X, m_SavedCursorPos.Y)
    m_BusyVerifying = True
    If VerifyScreenSavePwd(Me.hWnd) = False Then
       Do: DoEvents: Loop Until ShowCursor(False) < 0
       lRetVal = SetCursorPos(0, 0)
       Cancel = True
    End If
    m_BusyVerifying = False
End Sub
Private Sub Form_Terminate()
  Unload Me
End Sub
Private Sub Form_Unload(Cancel As Integer)
  Call Quit
End Sub

Private Sub Timer1_Timer()
chooseTransformMethod Me
Timer1.Enabled = False
End Sub


